#!/usr/bin/python3
import qcir
import encoder
import vettingMethod
import timeit
import igraph as ig
from testNauty import testGraph

def main():
	famousGraphs = [
		{"name": "Grotzsch", "graph": ig.Graph.Famous("Grotzsch"), "listsizes":[4], "timeout": "100s"},
		{"name": "Krackhardt_Kite", "graph": ig.Graph.Famous("Krackhardt_Kite"), "listsizes":[3, 4], "timeout": "100s"},
		{"name": "Octahedral", "graph": ig.Graph.Famous("Octahedral"), "listsizes":[3, 4], "timeout": "100s"},
		{"name": "Cubical", "graph": ig.Graph.Famous("Cubical"), "listsizes":[3], "timeout": "100s"},
		{"name": "Franklin", "graph": ig.Graph.Famous("Franklin"), "listsizes":[2, 3], "timeout": "100s"},
		{"name": "Petersen", "graph": ig.Graph.Famous("Petersen"), "listsizes":[3], "timeout": "100s"}, 
		#{"name": "nauty1", "graph": ig.Graph([[0, 5], [0, 6], [0, 7], [1, 5], [1, 6], [1, 7], [2, 5], [2, 6], [2, 7], [3, 5], [3, 6], [3, 7], [4, 7]]), "listsizes": [3], "timeout": "100s"},
		#{"name": "nauty2", "graph": ig.Graph([[0, 5], [0, 6], [0, 7], [1, 5], [1, 6], [1, 7], [2, 5], [2, 6], [2, 7], [3, 5], [3, 6], [3, 7], [4, 7], [5, 7]]), "listsizes": [3], "timeout": "100s"},
		#{"name": "nauty3", "graph": ig.Graph([[0, 5], [0, 6], [0, 7], [1, 5], [1, 6], [1, 7], [2, 5], [2, 6], [2, 7], [3, 5], [3, 6], [3, 7], [4, 7], [5, 7], [6, 7]]), "listsizes": [3], "timeout": "100s"},
		#{"name": "nauty4", "graph": ig.Graph([[0, 5], [0, 6], [0, 7], [1, 5], [1, 6], [1, 7], [2, 5], [2, 6], [2, 7], [3, 5], [3, 6], [3, 7], [4, 6], [4, 7]]), "listsizes": [3], "timeout": "100s"},
		#{"name": "nauty5", "graph": ig.Graph([[0, 5], [0, 6], [0, 7], [1, 5], [1, 6], [1, 7], [2, 5], [2, 6], [2, 7], [3, 5], [3, 6], [3, 7], [4, 6], [5, 7]]), "listsizes": [3], "timeout": "100s"},
		#{"name": "nauty720", "graph": ig.Graph([[0, 3], [0, 4], [0, 6], [0, 7], [1, 3], [1, 5], [1, 6], [2, 4], [2, 5], [3, 5], [3, 7], [4, 6], [4, 7], [5, 7]]), "listsizes": [3], "timeout": "100s"},
		]

	for graphInfo in famousGraphs:
		print(graphInfo["name"])
		print(graphInfo["graph"])
		for listsize in graphInfo["listsizes"]:
			print("testing  with qute")
			resultQute = testGraph(graphInfo["graph"], listsize, graphInfo["graph"].vcount(), solver="./qute", tempFilename=".temp/compareMethods", timeout=graphInfo["timeout"])
			print(resultQute)

			print("testing  with cqesto")
			resultCqesto = testGraph(graphInfo["graph"], listsize, graphInfo["graph"].vcount(), solver="./otherSolvers/cqesto", tempFilename=".temp/compareMethods", timeout=graphInfo["timeout"])
			print(resultCqesto)

			#print("testing vetting Method")
			#graph = graphInfo["graph"]
			#graph.vs[:]["listsize"] = [listsize] * graph.vcount()
			#graph.vs[:]["originalIndex"] = range(0,graph.vcount())
			#print(timeit.timeit(lambda: vettingMethod.testIfChoosable(graph), setup="pass", number=1))


if __name__ == "__main__":
	main()