#!/usr/bin/python3

from qcir import *
import igraph as ig
from encoder import *
from testcases import square

def printSimpleGraph():

	testedges =  [(0,3),(0,4),(0,5),(1,3),(1,4),(1,5),(2,3),(2,4),(2,5)]
	f = [2] * 6
	g = ig.Graph(edges=testedges)
	g.vs["listsize"] = f
	g["maxColorabilityClasses"] = 3
	
	subsets = [
		[0,1,3,4],
		[0,2,3,5],
		[1,2,4,5],
		[]
	]
	#print(encodingOnlyColorabilityClasses(g, subsets))
	print(encodingOnlyColorabilityClasses(g, subsets))

def printNelsenGraph():
	graphFromNelsenList =  [(0,1),(0,2),(1,2),(1,3),(3,4),(4,5),(4,6),(6,7),(7,8),(5,8),(5,9),(9,10),(9,11),(10,11)]
	f = [3,4,3,4,5,6,3,2,3,4,3,3]
	testgraph = ig.Graph(square(graphFromNelsenList))
	testgraph.vs[:]["listsize"] = f
	testgraph.vs[:]["originalIndex"] = range(0,12)

	#from vetting method
	subsets = [
	[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11],
	[0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11],
	[4, 5, 6, 7, 8, 9, 10, 11],
	[0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11],
	[4, 5, 6, 8, 9, 10, 11],
	[0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11],
	[4, 5, 6, 7, 9, 10, 11],
	[0, 1, 2, 3, 4, 5, 6, 9, 10, 11],
	[3, 4, 5, 6, 9, 10, 11],
	[4, 5, 6, 9, 10, 11],
	[1, 3, 4, 5, 9, 10, 11],
	[1, 4, 5, 9, 10, 11],
	[0, 1, 2, 3, 5, 9, 10, 11],
	[0, 1, 2, 5, 9, 10, 11],
	[5, 9, 10, 11],
	[1, 3, 4, 9, 10, 11],
	[1, 4, 9, 10, 11],
	[0, 1, 2, 3, 9, 10, 11],
	[0, 1, 2, 9, 10, 11],
	[9, 10, 11],
	[0, 1, 2, 3, 4, 5, 8, 9],
	[0, 1, 2, 4, 5, 8, 9],
	[4, 5, 8, 9],
	[0, 1, 2, 3, 4, 8, 9],
	[0, 1, 2, 4, 8, 9],
	[4, 8, 9],
	[0, 1, 2, 3, 4, 5, 9],
	[4, 5, 9],
	[0, 1, 2, 3, 4, 9],
	[4, 9],
	[0, 1, 2, 3, 4, 5, 6, 7, 8],
	[0, 1, 2, 4, 5, 6, 7, 8],
	[4, 5, 6, 7, 8],
	[0, 1, 2, 3, 4, 6, 7, 8],
	[0, 1, 2, 4, 6, 7, 8],
	[4, 6, 7, 8],
	[0, 1, 2, 3, 4, 5, 6, 8],
	[4, 5, 6, 8],
	[0, 1, 2, 3, 4, 6, 8],
	[4, 6, 8],
	[0, 1, 2, 3, 4, 5, 6, 7],
	[4, 5, 6, 7],
	[0, 1, 2, 3, 4, 6, 7],
	[4, 6, 7],
	[0, 1, 2, 3, 4, 5, 6],
	[3, 4, 5, 6],
	[4, 5, 6],
	[0, 1, 2, 3, 4, 6],
	[3, 4, 6],
	[4, 6],
	[1, 3, 4],
	[1, 4],
	[0, 1, 2, 3],
	[0, 1, 2],
	[],
	]

	#print(encodingOnlyColorabilityClasses(testgraph, subsets))
	print(basicEncoding(testgraph))

def main():
	printSimpleGraph()
	#printNelsenGraph()

if __name__ == "main":
	main()

main()
