#!/usr/bin/python3

import igraph as ig
import copy
import testcases

reducibleintersectionSizes = [0,0,0,0,0,0,0,0,0]

def appenderGenerator(startValue, imax, jmax):
	if startValue == []:
		for item in appenderGenerator([[1]], imax, jmax):
			yield item
		for item in appenderGenerator([[0]], imax, jmax):
			yield item
		return

	endArr = startValue[len(startValue) - 1]
	trueAppend = copy.deepcopy(startValue)
	falseAppend = copy.deepcopy(startValue)

	if(len(endArr) < jmax):
		trueAppend[len(trueAppend) - 1].append(1)
		for item in appenderGenerator(trueAppend, imax, jmax):
			yield item

		falseAppend[len(falseAppend) - 1].append(0)
		for item in appenderGenerator(falseAppend, imax, jmax):
			yield item
		
	elif(len(startValue) < imax):
		trueAppend.append([1])
		for item in appenderGenerator(trueAppend, imax, jmax):
			yield item
		falseAppend.append([0])
		for item in appenderGenerator(falseAppend, imax, jmax):
			yield item
	else:
		yield startValue

def appenderGeneratorPrune(startValue, imax, jmax, listsizes, graph: ig.Graph):
	#the pruning happens here
	#correct size
	for vals,listsize in zip(startValue,listsizes):
		if(sum(vals) > listsize):
			return
		if(sum(vals) + (jmax - len(vals))) < listsize:
			return
		if len(vals) == jmax and sum(vals) != listsize:
			print("error shouldnt be here")
			return

	invertedStart = [list(i) for i in zip(*startValue)]

	#ordering
	correctOrdering = True
	for list1,list2 in zip(invertedStart, invertedStart[1:]):
		correctOrderingLocal = False
		for item1,item2 in zip(list1, list2):
			if item1 > item2:
				correctOrderingLocal = True
			if not correctOrderingLocal and item2 > item1:
				correctOrdering = False
	if not correctOrdering:
		return

	#overlapping
	if len(startValue) == imax:
		for list1 in invertedStart:
			for list2 in invertedStart:
				exists1 = False
				exists2 = False
				overlapping = False
				for item1,item2 in zip(list1,list2):
					if item1:
						exists1 = True
					if item2:
						exists2 = True
					if item1 == 1 and item2 == 1:
						overlapping = True
						break
				if not overlapping and exists1 and exists2:
					return

	print("hi")
	#overlapping advanced
	if True and len(startValue) == imax:
		for list1 in invertedStart:
			l1exists = False
			for item1 in list1:
				if item1 == 1:
					l1exists = True
			if not l1exists:
				break
			for list2 in invertedStart:
				l2exists = False
				for item2 in list2:
					if item2 == 1:
						l2exists = True
				if not l2exists:
					break
				for list3 in invertedStart:
					l3exists = False
					for item3 in list3:
						if item3 == 1:
							l3exists = True
					if not l3exists:
						break
					oneTwoOverlapSize = 0
					
					reducibleOne = True
					reducibleTwo = True

					overlappingList = [0] * len(list1)
					verticesInOverlap = []
					verticesInL1 = []
					verticesNotInL1 = []
					verticesInL2 = []
					verticesNotInL2 = []
					verticesInL3 = []
					verticesNotInL3 = []
					for index,(item1,item2,item3) in enumerate(zip(list1,list2,list3)):
						if item1 == 1:
							verticesInL1.append(index)
						else:
							verticesNotInL1.append(index)
						if item2 == 1:
							verticesInL2.append(index)
						else:
							verticesNotInL2.append(index)
						if item3 == 1:
							verticesInL3.append(index)
						else:
							verticesNotInL3.append(index)
						if item1 == 1 and item2 == 1:
							verticesInOverlap.append(index)
							overlappingList[index] = 1

					graph.vs["oldIndex"] = range(100)

					list1Graph = graph.copy()
					list1Graph.delete_vertices(verticesNotInL1)

					list2Graph = graph.copy()
					list2Graph.delete_vertices(verticesNotInL2)

					list3Graph = graph.copy()
					list3Graph.delete_vertices(verticesNotInL3)
					
					intersectingComponents1 = []
					for component in list1Graph.connected_components():
						for overlappingVertex in overlappingList:
							if overlappingVertex in component:
								for componentVertex in component:
									intersectingComponents1.append(list1Graph.vs[componentVertex]["oldIndex"])
								break
					
					intersectingComponents2 = []
					for component in list2Graph.connected_components():
						for overlappingVertex in overlappingList:
							if overlappingVertex in component:
								for componentVertex in component:
									intersectingComponents2.append(list2Graph.vs[componentVertex]["oldIndex"])
								break

					overlappingIntersection1 = []
					overlappingIntersection2 = []
					flag1 = True
					flag2 = True

					if len(list3Graph.connected_components()) > 1:
						print(list3Graph)
						#print(list3Graph.vs[:]["oldIndex"])
						print(list3Graph.connected_components())

						for component in list3Graph.connected_components():
							print(component)
						exit()

					for component in list3Graph.connected_components():
						for vertex in intersectingComponents1:
							if flag1 and vertex in intersectingComponents1:
								for componentVertex in component:
									overlappingIntersection1.append(list3Graph.vs[componentVertex]["oldIndex"])
								flag1 = False
								if not flag2:
									break
							if flag1 and vertex in intersectingComponents2:
								for componentVertex in component:
									overlappingIntersection2.append(list3Graph.vs[componentVertex]["oldIndex"])
								flag2 = False
								if not flag1:
									break
					
					for list1Vertex in intersectingComponents1:
						if not list1Vertex in overlappingIntersection1:
							reducibleOne = False
							break
					for list3Vertex in overlappingIntersection1:
						if not list3Vertex in verticesInL1:
							for overlapVertex in verticesInOverlap:
								if graph.get_eid(list3Vertex,overlapVertex,error=False) == -1:
									reducibleOne = False
									break

					for list2Vertex in intersectingComponents2:
						if not list2Vertex in overlappingIntersection2:
							reducibleTwo = False
							break
					for list3Vertex in overlappingIntersection2:
						if not list3Vertex in verticesInL2:
							for overlapVertex in verticesInOverlap:
								if graph.get_eid(list3Vertex,overlapVertex,error=False) == -1:
									reducibleTwo = False
									break
					

#					#the vertices in this list MUST be in the third list
#					minList = [0] * len(list1)
#
#					#the vertices in this list MAY be in the third list
#					maxList = [0] * len(list1)


					
#					#if a value in list3 is connected to all overlapping vertices, it can be arbitrary and can be ignored for the connected component
#					list3CanBeTrue = [1] * len(list1)
#					overlappingNeighbors = [0] * len(list1)
#					matrix = graph.get_adjacency()
#
#					for index,overlappingItem in enumerate(overlappingList):
#						if overlappingItem == 1:
#							for neighborIndex,neighbor in enumerate(matrix[index]):
#								if neighbor == 0:
#									list3CanBeTrue[neighborIndex] = 0
#								if neighbor == 1 and overlappingList[neighborIndex] == 0:
#									overlappingNeighbors[neighborIndex] = 1
#
#					overlappingNeighbors1 = [0] * len(list1)
#					overlappingNeighbors2 = [0] * len(list1)
#
					for item1,item2,item3 in zip(list1,list2,list3):
						if item1 == 1 and item2 == 1:
							oneTwoOverlapSize += 1
							if item3 == 1:
								reducibleOne = False
								reducibleTwo = False
								break
#						elif item1 == 1 and item3 == 0:
#							reducibleOne = False
#							if not reducibleTwo:
#								break
#						elif item2 == 1 and item3 == 0:
#							reducibleTwo = False
#							if not reducibleOne:
#								break
#						#only allows subsets
#						elif item1 == 0 and item3 == 1:
#							reducibleOne = False
#							if not reducibleTwo:
#								break
#						elif item2 == 0 and item3 == 1:
#							reducibleTwo = False
#							if not reducibleOne:
#								break

					if reducibleOne or reducibleTwo:
						reducibleintersectionSizes[oneTwoOverlapSize] += oneTwoOverlapSize
						if oneTwoOverlapSize > 1:
							print("reduced with the following arrangement")
							print(list1)
							print(list2)
							print(list3)
							print("components1")
							print(intersectingComponents1)
							print("components2")
							print(intersectingComponents2)
						return


	if startValue == []:
		for item in appenderGeneratorPrune([[1]], imax, jmax, listsizes, graph):
			yield item
		for item in appenderGeneratorPrune([[0]], imax, jmax, listsizes, graph):
			yield item
		return

	endArr = startValue[len(startValue) - 1]
	trueAppend = copy.deepcopy(startValue)
	falseAppend = copy.deepcopy(startValue)

#	if(len(startValue) < imax):
#		trueAppend.append([1])
#		for item in appenderGeneratorPrune(trueAppend, imax, jmax, listsizes):
#			yield item
#		falseAppend.append([0])
#		for item in appenderGeneratorPrune(falseAppend, imax, jmax, listsizes):
#			yield item
#	else:
#		
#		for i,row in enumerate(startValue):
#			if(len(row) < jmax):
#				trueAppend[i].append(1)
#				for item in appenderGeneratorPrune(trueAppend, imax, jmax, listsizes):
#					yield item
#
#				falseAppend[i].append(0)
#				for item in appenderGeneratorPrune(falseAppend, imax, jmax, listsizes):
#					yield item
#				return
#		yield startValue
#		return

	if(len(endArr) < jmax):
		trueAppend[len(trueAppend) - 1].append(1)
		for item in appenderGeneratorPrune(trueAppend, imax, jmax, listsizes, graph):
			yield item

		falseAppend[len(falseAppend) - 1].append(0)
		for item in appenderGeneratorPrune(falseAppend, imax, jmax, listsizes, graph):
			yield item
		
	elif(len(startValue) < imax):
		trueAppend.append([1])
		for item in appenderGeneratorPrune(trueAppend, imax, jmax, listsizes, graph):
			yield item
		falseAppend.append([0])
		for item in appenderGeneratorPrune(falseAppend, imax, jmax, listsizes, graph):
			yield item
	else:
		yield startValue

#def invertGenerator(baseGen):
	#for item in baseGen:

		#for i in range(item):
			#for j in range(item[i]):
				#newItem =



def allGenerator(imax, jmax):
	baseAssignment = [[False for i in range(imax)] for j in range(jmax)]

i = 0
graphFromNielsenList =  [(0,1),(0,2),(1,2),(1,3),(3,4),(4,5),(4,6)]
g = ig.Graph(edges=testcases.square(graphFromNielsenList))
g.vs["listsize"] = [3,4,3,4,4,3,3,2,2,5,3,3]
#for appenderGeneratorPrune([], 6, 5, [2,2,3,3,4,4,5,5]), the difference between the old overlappin and the new overlapping is 1181 vs 32 colorings
for item in appenderGeneratorPrune([], 6, 5, [2,2,3,3,4,4,5,5,4,4], g):
	#print(item)
	i += 1
	
	if i % 1000 == 0:
		print("partial result")
		print(i)
		print(item)

print("endResult")
print(i)
print(reducibleintersectionSizes)
	