#!/usr/bin/python3

import igraph as ig
import subprocess
from qcir import *
import encoder as ec
import preprocessor as pp
import json

from testNauty import testGraph

def main():
	famousGraphs = [
		{"name": "Grptzsch", "graph": ig.Graph.Famous("Grotzsch"), "listsizes":[4], "timeout": "100s"},
		{"name": "Krackhardt_Kite", "graph": ig.Graph.Famous("Krackhardt_Kite"), "listsizes":[3, 4], "timeout": "100s"},
		{"name": "Octahedral", "graph": ig.Graph.Famous("Octahedral"), "listsizes":[3, 4], "timeout": "100s"},
		{"name": "Cubical", "graph": ig.Graph.Famous("Cubical"), "listsizes":[3], "timeout": "100s"},
		{"name": "Franklin", "graph": ig.Graph.Famous("Franklin"), "listsizes":[2, 3], "timeout": "1000s"},
		{"name": "Petersen", "graph": ig.Graph.Famous("Petersen"), "listsizes":[3], "timeout": "1000s"}, 
		]
	

	for graphInfo in famousGraphs:
		print(graphInfo["name"])
		print(graphInfo["graph"])
		for listsize in graphInfo["listsizes"]:
			testGraph(graphInfo["graph"], listsize, graphInfo["graph"].vcount(), tempFilename=".temp/famousGraphTester", timeout=graphInfo["timeout"])

if __name__ == "__main__":
	main()